package TVListings::edit;

use strict;
use warnings;

use Apache::Constants qw/:http/;
use CGI qw/escapeHTML/;
use Encode;

use TVListings::Config;
use TVListings::DB qw/SQL_DEL_INTEREST SQL_INS_INTEREST/;

sub render {
	my ($class, $r, $q, $dbh) = @_;
	my $out = pagehead($r, $q, 'TV Show Edit');
	$out .= '<br/>';
	
	if (!$q->param('prg_title')) {
		$out .= 'Bad prg title';
	} else {
		my $prg_title = decode('iso-8859-1', $q->param('prg_title'));
		# we need to convert prg_title back to utf8 octets (not string!)
		my $ptoctets = encode('utf8', $prg_title);
		eval {
			my $sth = $dbh->prepare_cached(SQL_DEL_INTEREST);
			$sth->execute($ptoctets);
			if ($q->param('pint_class')) {
				$sth = $dbh->prepare_cached(SQL_INS_INTEREST);
				$sth->execute($ptoctets, $q->param('pint_class'));
			}
			$dbh->commit;
		};
		if ($@) {
			$out .= "failed interestizing:<br/><tt>" . escapeHTML($@) . "</tt>";
		} else {
			$out .= "Interest for '" . escapeHTML($ptoctets) . "' saved<br/>";
		}
	}
	
	$out .= pagefoot($r, $q);
	
	return {
		hdrs => [['Refresh', '0.1;url=' . ($q->param('returl') || './')]],
		status => HTTP_OK,
		text => $out,
	};
}

1;
